package eu.dnetlib.loginservice;

import eu.dnetlib.loginservice.properties.APIProperties;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.PropertySource;
import org.springframework.context.annotation.PropertySources;
import eu.dnetlib.loginservice.properties.Properties;

@SpringBootApplication(scanBasePackages = {"eu.dnetlib.loginservice"})
@PropertySources({
        @PropertySource("classpath:authentication.properties"),
        @PropertySource(value = "classpath:dnet-override.properties", ignoreResourceNotFound = true)
})
@EnableConfigurationProperties({Properties.class, APIProperties.class})
public class LoginServiceApplication {

    public static void main(String[] args) {
        SpringApplication.run(LoginServiceApplication.class, args);
    }

}
